/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.3d21, January 17, 1991
 *  Copyright (c) 1988, 1989, 1990, 1991 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "types.r"
#include "vers.r"

#define the_datestr "February 22, 1990"
#define the_majorver 0x1
#define the_minorver 0x0
#define the_stage development
#define the_build 0x3
#define the_verstr "1.0d3"

type 'GFTK' {
		pstring;
};

resource 'GFTK' (0, preload) {
	"KeyMap (for tn3270) by Peter DiCamillo Version "
	the_verstr "  " the_datestr
};

resource 'vers' (1, preload) {
	the_majorver,
	the_minorver,
	the_stage,
	the_build,
	verUs,
	the_verstr,
	the_verstr " " the_datestr
};

resource 'FREF' (12325) {
	'APPL',
	0,
	""
};

resource 'BNDL' (12325) {
	'GFTK',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 element */
			/* [1] */
			0, 12325
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 element */
			/* [1] */
			0, 12325
		}
	}
};

resource 'FREF' (12325) {
	'APPL',
	0,
	""
};

resource 'ICN#' (12325) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFDF FBFF 8050 0A01 8C53 8A71 9252 4A89"
		$"9253 8A81 9E52 4A81 9252 4A89 9253 8A71"
		$"8050 0A01 FFDF FBFF 0000 0000 FFDF FBFF"
		$"8050 0A01 8051 0A11 8053 8AF9 BE57 CA21"
		$"8251 0AF9 8251 0A41 8051 0A01 8050 0A01"
		$"FFDF FBFF 0000 0000 FFDF FBFF 8050 0A01"
		$"8051 0A01 8851 0A11 9851 0A19 BF57 CAFD"
		$"9853 8A19 8851 0A11 8050 0A01 FFDF FBFF",
		/* [2] */
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF 0000 0000 FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF 0000 0000 FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	}
};

resource 'MENU' (256, preload) {
	256,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About KeyMap...", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (257, preload) {
	257,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	{	/* array: 6 elements */
		/* [1] */
		"Open definition file", noIcon, "", "", plain,
		/* [2] */
		"Show definition info", noIcon, "", "", plain,
		/* [3] */
		"Write Rez text file", noIcon, "", "", plain,
		/* [4] */
		"Write resource to existing file", noIcon, "", "", plain,
		/* [5] */
		"Write resource to new file", noIcon, "", "", plain,
		/* [6] */
		"Quit", noIcon, "", "", plain
	}
};

resource 'MENU' (258, preload) {
	258,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "X", "", plain,
		/* [4] */
		"Copy", noIcon, "C", "", plain,
		/* [5] */
		"Paste", noIcon, "V", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain
	}
};

resource 'ALRT' (256, preload) {
	{88, 76, 214, 436},
	256,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'DITL' (256, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 140, 114, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DLOG' (257, preload) {
	{86, 96, 256, 416},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	257,
	""
};

resource 'DITL' (257, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{122, 119, 157, 202},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{13, 25, 54, 296},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{63, 21, 113, 296},
		StaticText {
			disabled,
			"Use KeyMap to define a new keyboard "
			"mapping for tn3270 from a definition file."
		}
	}
};

resource 'DLOG' (258, preload) {
	{100, 100, 249, 364},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	258,
	""
};

resource 'DITL' (258, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{100, 157, 127, 237},
		Button {
			enabled,
			"Cancel"
		},
		/* [2] */
		{100, 26, 127, 106},
		Button {
			enabled,
			"Replace"
		},
		/* [3] */
		{16, 17, 71, 246},
		StaticText {
			disabled,
			"Replace the existing map resource named "
			"\"^0\"?"
		}
	}
};

resource 'DLOG' (259, preload) {
	{100, 100, 376, 438},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	259,
	""
};

resource 'DITL' (259, preload) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{225, 131, 257, 210},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{21, 13, 56, 327},
		StaticText {
			disabled,
			"File: ^0"
		},
		/* [3] */
		{75, 13, 110, 327},
		StaticText {
			disabled,
			"Last Modified: ^1"
		},
		/* [4] */
		{129, 13, 166, 327},
		StaticText {
			disabled,
			"Resource map name: ^2"
		},
		/* [5] */
		{183, 13, 202, 327},
		StaticText {
			disabled,
			"Rez file resource number: ^3"
		}
	}
};

resource 'ALRT' (260, preload) {
	{51, 76, 251, 436},
	260,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'DITL' (260, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{156, 140, 188, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{82, 72, 148, 332},
		StaticText {
			disabled,
			"^1"
		}
	}
};

resource 'cicn' (12325, purgeable) {
	16,
	{0, 0, 32, 32},
	0,
	unpacked,
	0,
	0x480000,
	0x480000,
	chunky,
	4,
	1,
	4,
	0,
	0,
	4,
	{0, 0, 32, 32},
	4,
	{0, 0, 32, 32},
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF FFDF FBFF 0000 0000 FFDF FBFF"
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF 0000 0000 FFDF FBFF FFDF FBFF"
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	$"FFDF FBFF 8050 0A01 8C53 8A71 9252 4A89"
	$"9253 8A81 9E52 4A81 9252 4A89 9253 8A71"
	$"8050 0A01 FFDF FBFF 0000 0000 FFDF FBFF"
	$"8050 0A01 8051 0A11 8053 8AF9 BE57 CA21"
	$"8251 0AF9 8251 0A41 8051 0A01 8050 0A01"
	$"FFDF FBFF 0000 0000 FFDF FBFF 8050 0A01"
	$"8051 0A01 8851 0A11 9851 0A19 BF57 CAFD"
	$"9853 8A19 8851 0A11 8050 0A01 FFDF FBFF"
	$"0000 0000 0000 0004 0000 FFFF FFFF FFFF"
	$"0001 FFFF 0000 0000 0002 0000 0000 FFFF"
	$"0003 DFFF DFFF DFFF 0004 0000 0000 0000"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4333 2233 3404 3322 2333 4043 3222 3334"
	$"4332 3323 3404 3323 3233 4043 2333 2334"
	$"4332 3323 3404 3322 2333 4043 2333 3334"
	$"4332 2223 3404 3323 3233 4043 2333 3334"
	$"4332 3323 3404 3323 3233 4043 2333 2334"
	$"4332 3323 3404 3322 2333 4043 3222 3334"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4333 3333 3404 3331 3333 4043 3332 3334"
	$"4333 3333 3404 3311 1333 4043 2222 2334"
	$"4322 2223 3404 3111 1133 4043 3323 3334"
	$"4333 3323 3404 3331 3333 4043 2222 2334"
	$"4333 3323 3404 3331 3333 4043 3233 3334"
	$"4333 3333 3404 3331 3333 4043 3333 3334"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4333 3333 3404 3331 3333 4043 3333 3334"
	$"4333 1333 3404 3331 3333 4043 3331 3334"
	$"4331 1333 3404 3331 3333 4043 3331 1334"
	$"4311 1111 3404 3111 1133 4043 1111 1134"
	$"4331 1333 3404 3311 1333 4043 3331 1334"
	$"4333 1333 3404 3331 3333 4043 3331 3334"
	$"4333 3333 3404 3333 3333 4043 3333 3334"
	$"4444 4444 4404 4444 4444 4044 4444 4444"
};




