/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.3d21, January 17, 1991
 *  Copyright (c) 1988, 1989, 1990, 1991 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
 
#ifndef __TYPES__
#include	<Types.h>
#endif

typedef short			ABCallType;
typedef unsigned char	Byte;

typedef String(32)		Str32;

typedef struct {
	short			aNet;
	Byte			aNode;
	Byte			aSocket;
} AddrBlock;

typedef struct {
	Str32			objStr;
	Str32			typeStr;
	Str32			zoneStr;
} EntityName, *EntityPtr;

typedef struct {
	Byte			retransInterval;
	Byte			retransCount;
} RetransType;

typedef struct {
	short			buffSize;
	Ptr				buffPtr;
	short			dataSize;
	/* long			userBytes; */
	short			sessionId;
	unsigned char	typeCode;
	unsigned char	seqNum;
} BDSElement;
typedef BDSElement	BDSType[8];
typedef BDSType *	BDSPtr;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	EntityPtr		nbpEntityPtr;
	Ptr				nbpBufPtr;
	short			nbpBufSize;
	short			nbpDataField;
	AddrBlock		nbpAddress;
	RetransType		nbpRetransmitInfo;
} NBPRecord, *NBPRecPtr, **NBPRecHdl;

typedef struct {
	ABCallType		abOpcode;
	short			abResult;
	long			abUserReference;
	short			atpSocket;
	AddrBlock		atpAddress;
	short			atpReqCount;
	Ptr				atpDataPtr;
	BDSPtr			atpRspBDSPtr;
	unsigned char	atpBitMap;
	short			atpTransId;
	short			atpActCount;
	/* long			atpUserData; */
	short			atpSessionId;
	unsigned char	atpTypeCode;
	unsigned char	atpSeqNum;
	Boolean			atpXO;
	Boolean			atpEOM;
	short			atpTimeOut;
	short			atpRetries;
	short			atpNumBufs;
	short			atpNumRsp;
	short			atpBDSSize;
	long			atpRspUData;
	Ptr				atpRspBuf;
	short			atpRspSize;
} ATPRecord, *ATPRecPtr, **ATPRecHdl;

pascal OSErr			MPPOpen();
pascal OSErr			NBPLoad();
pascal OSErr			NBPUnload();
pascal OSErr			NBPLookup();
pascal OSErr			NBPConfirm();
pascal OSErr			NBPRegister();
pascal OSErr			NBPRemove();
pascal OSErr			NBPExtract();
pascal OSErr			ATPLoad();
pascal OSErr			ATPUnload();
pascal OSErr			ATPOpenSocket();
pascal OSErr			ATPCloseSocket();
pascal OSErr			ATPSndRequest();
pascal OSErr			ATPGetRequest();
pascal OSErr			ATPSndRsp();
pascal OSErr			ATPAddRsp();

typedef struct {
	struct atpSndParamBlk *	ioLink;
	short					ioType;
	short					ioTrap;
	Ptr						ioCmdAddr;
	ProcPtr					ioCompletion;
	short					ioResult;
	short					sessionId;
	unsigned char			typeCode;
	unsigned char			seqNum;
	short					ioVRefNum;
	short					csRefNum;
	short					csCode;
	unsigned char			currBitMap;
	unsigned char			atpFlags;
	struct {
		short	aNet;
		Byte	aNode;
		Byte	aSocket;
		}					addrBlock;
	short					reqLength;
	char *					reqPointer;
	char *					bdsPointer;
	unsigned char			numOfBuffs;
	unsigned char			timeOutVal;
	unsigned char			numOfResps;
	unsigned char			retryCount;
} atpSndParamBlk;

typedef struct {
	struct atpGetParamBlk *	ioLink;
	short					ioType;
	short					ioTrap;
	Ptr						ioCmdAddr;
	ProcPtr					ioCompletion;
	short					ioResult;
	short					sessionId;
	unsigned char			typeCode;
	unsigned char			seqNum;
	short					ioVRefNum;
	short					csRefNum;
	short					csCode;
	Byte					atpSocket;
	unsigned char			atpFlags;
	struct {
		short	aNet;
		Byte	aNode;
		Byte	aSocket;
		}					addrBlock;
	short					reqLength;
	char *					reqPointer;
	char *					getblk40;
	unsigned char			bitMap;
	unsigned char			getblk45;
	short					transID;
	long					savedA5;
} atpGetParamBlk;

typedef struct {
	struct atpSnRParamBlk *	ioLink;
	short					ioType;
	short					ioTrap;
	Ptr						ioCmdAddr;
	ProcPtr					ioCompletion;
	short					ioResult;
	short					sessionId;
	unsigned char			typeCode;
	unsigned char			seqNum;
	short					ioVRefNum;
	short					csRefNum;
	short					csCode;
	Byte					atpSocket;
	unsigned char			atpFlags;
	struct {
		short	aNet;
		Byte	aNode;
		Byte	aSocket;
		}					addrBlock;
	short					snr34;
	char *					snr36;
	char *					bdsPointer;
	unsigned char			numOfBuffs;
	unsigned char			bdsSize;
	short					transID;
} atpSnRParamBlk;
