/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.3d21, January 17, 1991
 *  Copyright (c) 1988, 1989, 1990, 1991 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "types.r"

type 'mstr' {
		pstring;	
};

type 'WSFR' {
	unsigned integer;		/* total length */
	unsigned hex byte;		/* WSF code 0x81 */
	unsigned hex byte;		/* WSF type	*/
	hex string;
};

type 'HNAM' {pstring;};

resource 'HNAM' (0, preload) {		/* default PCNET host */
	"BROWNVM"
};

resource 'HNAM' (1, preload) {		/* default serial host (baud rate) */
	"9600"
};

resource 'FREF' (23460) {
	'APPL',
	0,
	""
};

resource 'FREF' (23461) {
	'GFTS',
	1,
	""
};

resource 'BNDL' (23460) {
	'GFTM',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 23460,
			/* [2] */
			1, 23461
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 23460,
			/* [2] */
			1, 23461
		}
	}
};

resource 'WSFR' (128, "SUMMARY", preload) {
	22,
	0x81,
	0x80,
	$"8081 8485 8687 88A1 A6A8 9699 B0B1 B2B3"
	$"B4B6"
};

resource 'WSFR' (244, "SUMMARY", preload) {
	9,
	0x81,
	0x80,
	$"8081 85A1 A6"
};

resource 'WSFR' (129, "UAREA", preload) {		/* modified by screen format */
	46,
	0x81,
	0x81,
	$"0300 0000 0000 0000 0100 4800 0100 4800"
	$"0000 0000 0000 0013 0200 0100 0000 0000"
	$"0001 0048 0001 0048 0000"
};

resource 'WSFR' (132, "ALNMPART", preload) {
	8,
	0x81,
	0x84,
	$"000A 0004"
};

resource 'WSFR' (133, "SYMSETS", preload) {		/* 9-pt default */
	34,
	0x81,
	0x85,
	$"8200 060C 0000 0000 07"
	$"0000 0000 6500 25"
	$"0000 0002 B900 25"
	$"0100 F103 C301 36"
};

resource 'WSFR' (251, "SYMSETS", preload) {		/* 9-pt PS simulation */
	48,
	0x81,
	0x85,
	$"F200 060C 7000 0000 07"
	$"0000 0000 6500 25"
	$"0000 0002 B900 25"
	$"0100 F103 C301 36"
	$"0280 FF00 0000 00"
	$"0380 FF00 0000 00"
};

resource 'WSFR' (252, "SYMSETS", preload) {		/* 12-pt default */
	34,
	0x81,
	0x85,
	$"8200 0710 0000 0000 07"
	$"0000 0000 6500 25"
	$"0000 0002 B900 25"
	$"0100 F103 C301 36"
};

resource 'WSFR' (253, "SYMSETS", preload) {		/* 12-pt PS simulation */
	48,
	0x81,
	0x85,
	$"F200 0710 7000 0000 07"
	$"0000 0000 6500 25"
	$"0000 0002 B900 25"
	$"0100 F103 C301 36"
	$"0280 FF00 0000 00"
	$"0380 FF00 0000 00"
};

resource 'WSFR' (134, "COLOR", preload) {		/* color not included */
	22,
	0x81,
	0x86,
	$"0008 00F4 F100 F200 F300 F400 F500 F600"
	$"F700"
};

resource 'WSFR' (245, "COLOR", preload) {		/* color included */
	22,
	0x81,
	0x86,
	$"0008 00F4 F1F1 F2F2 F3F3 F4F4 F5F5 F6F6"
	$"F7F7"
};

resource 'WSFR' (135, "EXTHIGH", preload) {
	13,
	0x81,
	0x87,
	$"0400 F0F1 F1F2 F2F4 F4"
};

resource 'WSFR' (136, "RPLYMODE", preload) {
	7,
	0x81,
	0x88,
	$"0001 02"
};

resource 'WSFR' (150, "STGPOOLS", preload) {
	17,
	0x81,
	0x96,
	$"0D01 0100 006C 0000 006C 0000 07"
};

resource 'WSFR' (153, "AUXDEV", preload) {
	6,
	0x81,
	0x99,
	$"0000"
};

resource 'WSFR' (161, "RPQNAMES", preload) {
	18,
	0x81,
	0xA1,
	$"C7C6 E3D4 0000 0000 06F0 F24B F3F1"	/* GFTM version 02.31 */
};

resource 'WSFR' (166, "IMPLPART", preload) {	/* modified by screen format */
	28,
	0x81,
	0xA6,
	$"0000 0B01 0000 0000 0000 0000 000B 0200"
	$"0000 0000 0000 0000"
};

resource 'WSFR' (168, "BKXPARNT", preload) {
	9,
	0x81,
	0xA8,
	$"0200 F0FF FF"
};

resource 'WSFR' (176, "SEGMENT", preload) {
	26,
	0x81,
	0xB0,
	$"0002 0000 00FF FF05 0200 8000 0502 0480"
	$"0005 020B 8000"
};

resource 'WSFR' (177, "PROCEDUR", preload) {
	21,
	0x81,
	0xB1,
	$"0001 0000 00FF FF06 0006 0006 01FF FFFF"
	$"F0"
};

resource 'WSFR' (178, "LINETYPE", preload) {
	24,
	0x81,
	0xB2,
	$"0009 0007 0101 0202 0303 0404 0505 0606"
	$"0707 0808"
};

resource 'WSFR' (179, "PORT", preload) {
	17,
	0x81,
	0xB3,
	$"0005 0290 0901 0001 0280 007F FF"
};

resource 'WSFR' (254, "PORT", preload) {
	15,
	0x81,
	0xB3,
	$"0007 0840 0703 0001 0000 1C"
};

resource 'WSFR' (180, "GRHCOLOR", preload) {
	61,
	0x81,
	0xB4,
	$"0004 0001 FF00 0800 0800 0000 0000 0000"
	$"0100 0100 0000 0201 0000 0000 0301 0100"
	$"0000 0400 0001 0000 0500 0101 0000 0601"
	$"0001 0000 0701 0101 00"
};

resource 'WSFR' (182, "GRSYMBOL", preload) {
	133,
	0x81,
	0xB6,
	$"7080 060C 0100 0200 0000 0070 0000 0010"
	$"0100 00F0 0202 0000 0000 0002 B900 2510"
	$"0100 00F0 0202 0000 060C 0002 B900 2510"
	$"0100 00F0 8383 0000 0000 0002 B900 250B"
	$"0102 80FF 0202 0101 060C 0B01 0380 FF02"
	$"0201 0106 0C0B 0108 88FF 0202 0101 060C"
	$"0B01 0988 FF02 0201 0106 0C0B 010A 88FF"
	$"0202 0101 060C 0B01 0B88 FF02 0201 0106"
	$"0C"
};

resource 'WSFR' (250, "GRSYMBOL", preload) {
	133,
	0x81,
	0xB6,
	$"7080 0710 0100 0200 0000 0070 0000 0010"
	$"0100 00F0 0202 0000 0000 0002 B900 2510"
	$"0100 00F0 0202 0000 0710 0002 B900 2510"
	$"0100 00F0 8383 0000 0000 0002 B900 250B"
	$"0102 80FF 0202 0101 0710 0B01 0380 FF02"
	$"0201 0107 100B 0108 88FF 0202 0101 0710"
	$"0B01 0988 FF02 0201 0107 100B 010A 88FF"
	$"0202 0101 0710 0B01 0B88 FF02 0201 0107"
	$"10"
};

resource 'WSFR' (255, "NULL", preload) {
	4,
	0x81,
	0xFF,
	$""
};

resource 'CURS' (20845, preload) {
	$"0000 0000 0000 0FE0 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0FE0",
	$"0000 0000 0000 0FE0 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0FE0",
	{8, 7}
};

resource 'CURS' (20846, preload) {
	$"0FE0 0820 0820 0820 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0820 0820 0FE0",
	$"0FE0 0820 0820 0820 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0820 0820 0FE0",
	{8, 9}
};

resource 'CURS' (20847, preload) {
	$"",
	$"0000 0000 0000 0FE0 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0FE0",
	{8, 7}
};

resource 'CURS' (20848, preload) {
	$"",
	$"0FE0 0820 0820 0820 0820 0820 0820 0820"
	$"0820 0820 0820 0820 0820 0820 0820 0FE0",
	{8, 9}
};

data 'GFKB' (128, "default", preload) {
											/* keybuffn */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"009A 00AC 00B8 0000 0000 00A9 9B00 B600"
$"00A8 9990 9192 9394 9596 0097 9800 0000"
$"9495 9692 9798 009A 009C 009D 0099 009B"
$"009E 90B5 96B9 9392 9197 9000 0000 0000"
											/* keybuffs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"00A6 AC00 0000 B800 A800 0000 A7A9 B700"
$"0000 A59C 9D9E 9FA0 A1A2 00A3 A400 0000"
$"A0A1 A29E A3A4 00A6 0000 0000 00A5 00A7"
$"0000 0000 0000 9F00 9D00 9C00 0000 0000"
											/* keybuffc */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffo */
$"6274 6567 6968 7B79 6477 0063 7278 6673"
$"7A75 7C7D 7E7F 8180 8784 8286 8385 8870"
$"7600 6A71 006D 6B8B 6C8A 898C 8E6F 6E8D"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffn */
$"0000 00B4 0000 0000 B0B2 0000 008F 0000"
$"0000 0000 0000 0000 0000 00AB B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffs */
$"0000 00B4 0000 0000 B9B3 0000 00B4 0000"
$"0000 0000 0000 0000 0000 00AB B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffc */
$"0000 00AA 0000 0000 BF00 0000 00B5 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 A89A A9AC"
$"9990 9192 9394 9596 9798 0000 009B 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 AA00 0000"
$"00BD 00AB BBB6 BCC5 B0B8 B1B1 ADAF AF00"
$"C400 BA00 00AE 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 00A6 0000"
$"A59C 9D9E 9FA0 A1A2 A3A4 0000 00A7 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 00B7 0000 C200 C3C3 00C1 C100"
$"0000 0000 00C0 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffo */
$"0000 0000 0000 0000 BE00 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 C2C3 C0C1"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"1100 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0200 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
};

data 'GFKB' (129, "numeric keypad", preload) {
											/* keybuffn */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 B400 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"9495 9692 9798 009A 009C 009D 0099 009B"
$"009E 90B5 96B9 9392 9197 9000 0000 0000"
											/* keybuffs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"A0A1 A29E A3A4 00A6 0000 0000 00A5 00A7"
$"0000 0000 0000 9F00 9D00 9C00 0000 0000"
											/* keybuffc */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffo */
$"6274 6567 6968 7B79 6477 0063 7278 6673"
$"7A75 7C7D 7E7F 8180 8784 8286 8385 8870"
$"7600 6A71 006D 6B8B 6C8A 898C 8E6F 6E8D"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffn */
$"0000 00B4 0000 0000 B0B2 0000 008F 0000"
$"0000 0000 0000 0000 0000 00AB B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffs */
$"0000 00B4 0000 0000 B9B3 0000 00B4 0000"
$"0000 0000 0000 0000 0000 00AB B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffc */
$"0000 00AA 0000 0000 BF00 0000 00B5 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 A89A A9AC"
$"9990 9192 9394 9596 9798 0000 009B 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 AA00 0000"
$"00BD 00AB BBB6 BCC5 B0B8 B1B1 ADAF AF00"
$"C400 BA00 00AE 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 00A6 0000"
$"A59C 9D9E 9FA0 A1A2 A3A4 0000 00A7 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 00B7 0000 C200 C3C3 00C1 C100"
$"0000 0000 00C0 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffo */
$"0000 0000 0000 0000 BE00 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 C2C3 C0C1"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"1100 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0200 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
};

data 'GFKB' (130, "ala", preload) {
											/* keybuffn */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"00FF 00FF 00FF 0000 0000 00FF FF00 FF00"
$"00FF 00FF FFFF FFFF FFFF 00FF FF00 0000"
$"9495 9692 9798 009A 009C 009D 0099 009B"
$"009E B8AB 96B9 93B6 9197 9000 0000 0000"
											/* keybuffs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 FFFF 00FF FF00 FF00 0000 FFFF FF00"
$"00FF 00FF 00FF FF00 FF00 00FF FF00 0000"
$"A0A1 A29E A3A4 00A6 0000 0000 00A5 00A7"
$"0000 0000 0000 9F00 9D00 9C00 0000 0000"
											/* keybuffc */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"009A 0000 0000 0000 0000 0000 9B00 0000"
$"0000 9990 9192 9394 9596 0097 9800 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"00A6 FF00 0000 FF00 FF00 0000 A700 0000"
$"0000 A59C 9D9E 9FA0 A1A2 00A3 A400 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* keybuffo */
$"0000 BBBC 0000 0000 0000 0000 0000 0000"
$"0000 FFFF FFFF FFFF FFFF FFFF FFFF 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffn */
$"0000 00B4 0000 0000 B0B2 0000 008F 0000"
$"0000 0000 0000 0000 0000 00FF B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffs */
$"0000 00B4 0000 0000 B9B3 0000 00B4 0000"
$"0000 0000 0000 0000 0000 00FF B0B1 AEAF"
$"0109 1D19 0A13 081B 050C 0B06 120F 0310"
$"5859 5A5B 5C5D 5E5F 6061 180D 041C 1516"
$"1A3C 3D3E 3F40 4142 4344 4647 4849 4A4B"
$"4C4D 4E50 5152 5354 5556 5739 4F3A 0E14"
$"171E 1F20 2122 2324 2526 2728 292A 2B2C"
$"2D2E 2F31 3233 3435 3637 383B 0745 3000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffc */
$"0000 00AA 0000 0000 BF00 0000 00B5 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 A8FF A9AC"
$"FFFF FFFF FFFF FFFF FFFF 0000 00FF 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 00FF FFFF 0000"
$"00FF FFFF FFFF FFFF 00FF 0000 AD00 0000"
$"00FF FFFF FFFF FFFF FFFF FF00 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffcs */
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 00FF 0000"
$"FFFF FFFF FFFF FFFF FFFF 0000 00FF 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 00FF 00FF 0000"
$"0000 FF00 00FF 00FF 00FF 0000 0000 0000"
$"00FF FF00 FFFF FFFF FFFF FF00 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* ascbuffo */
$"0000 0000 0000 0000 BE00 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 C2C3 C0C1"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"1100 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0200 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
$"0000 0000 0000 0000 0000 0000 0000 0000"
											/* hexbuff */
$"04B1 7100 04B2 7200 04B3 7300 04B4 7400"
$"04B5 7500 04B6 7600 04B7 7700 04B8 7800"
$"04B9 9000 04B0 7000 04AD AE00 04BD AA00"
$"0212 B100 05B1 B100 0213 B200 05B2 B200"
$"0214 B300 05B3 B300 0215 B400 05B4 B400"
$"0217 B500 05B5 B500 0216 B600 05B6 B600"
$"021A B700 05B7 B700 021C B800 05B8 B800"
$"0219 B900 05B9 B900 021D B000 05B0 B000"
$"021B BE00 05AD BE00 0218 BA00 05BD BA00"
$"05F1 4500 05F7 4300 05E5 4100 05F2 4600"
$"05F4 4700 05F9 4200 05F5 4400 05E9 4800"
$"05DB BB00 05DD BF00 04F1 5500 04F7 5300"
$"04E5 5100 04F2 5600 04F4 5700 04F9 5200"
$"04F5 5400 04E9 5800 04DB AB00 04DD AF00"
$"04DC 6900 04E1 FA00 04F3 6500 04E4 6200"
$"04E6 6300 04E7 4900 05E7 5900 04FA 8000"
$"05FA E100 04F8 6600 05F8 6700 04E3 FC00"
$"04F6 6800 05F6 A000 04E2 FB00 05E2 6400"
$"029B DD00 039B 8D00 0051 ED00 00D1 EE00"
$"00C8 ED00 01C8 EE00 004B CC00 00CD CC00"
$"0043 8F00 00C2 8F00 00C3 9F00 01C2 9F00"
$"0059 8C00 005B 9B00 00DB DF00 005C DE00"
$"00DC CD00 004E EC00 00CE DC00 0056 9C00"
$"00D6 9D00 0057 CE00 0058 DA00 00D8 EA00"
$"0045 DB00 00C6 DB00 00C5 EB00 01C6 EB00"
$"0053 CB00 00D3 8B00 0054 9A00 0055 CA00"
$"00D5 8A00 004C 8E00 00CC 9E00 0041 CF00"
};

data 'GFNL' (128, "ALA (Library Catalog)", preload) {
$"F4"
};

data 'GFNL' (129, "ALA, adjacent characters", preload) {
$"F480 00"
};

data 'GFNL' (130, "Austrian/German", preload) {
$"4AB7 4F5A 5ABB 5F53 6A78 7C48 A147 C075 D080 E0BA"
};

data 'GFNL' (131, "Austrian/German (Alternate)", preload) {
$"4A78 5A80 5BBB 6A47 7BB7 7CBA 7F75"
};

data 'GFNL' (132, "Danish/Norwegian", preload) {
$"4A7B 4F5A 5A46 5BFC 5F53 6AEA 7BFA 7CFB A180 C0E1 D0EB"
};

data 'GFNL' (133, "Danish/Norwegian (Alternate)", preload) {
$"4AEA 5AEB 5BFC 7BFA 7CFB 7FE1"
};

data 'GFNL' (134, "Finnish/Swedish", preload) {
$"4A48 4F5A 5A46 5BFC 5F53 6A78 7990 7BB7 7CBA A180 C075 D0EB E0CC"
};

data 'GFNL' (135, "Finnish/Swedish (Alternate)", preload) {
$"4A78 5AEB 5BFC 7BB7 7CBA 7F75"
};

data 'GFNL' (136, "French", preload) {
$"4A51 4F5A 5A48 5F53 6A63 7B43 7C57 A154 C090 D058 E074"
};

data 'GFNL' (137, "Italian", preload) {
$"4A51 4F5A 5A90 5F53 6A62 7963 7B43 7C48 A159 C057 D058 E074"
};

data 'GFNL' (138, "Portuguese", preload) {
$"4A41 4F5A 5A42 5F53 6A65 7BAC 7CAD A174 C064 D055 E0FD"
};

data 'GFNL' (139, "Spanish", preload) {
$"4A41 5A42 5B45 6A9D 7BDC A154"
};

data 'GFNL' (140, "Spanish (Alternate)", preload) {
$"5B45 7BDC 7F9D"
};

data 'GFNL' (141, "English (UK)", preload) {
$"4A5B 5B43 A149"
};

data 'GFNL' (142, "Belgian", preload) {
$"4A41 4F5A 5A42 5F53 6A63 7C57 A154 C090 D058 E074"
};

data 'GFNL' (143, "Brazilian/Portuguese", preload) {
$"4ACC 4F5A 5A5B 5BFD 5F53 6A74 7964 7BAD 7CAC C065 D090"
};

data 'GFNL' (144, "Japanese (English)", preload) {
$"4A43 5B44 A149 E05B"
};

data 'GFNL' (145, "Spanish Speaking", preload) {
$"4A41 5A42 6A9D 7BDC A154"
};

data 'GFNL' (146, "Canadian (French)", preload) {
$"4A57 4F5A 5A55 5F53 6A63 A154 C090 D058 E074"
};

data 'GFNL' (147, "International", preload) {
$"4A41 4F5A 5A42 5F53"
};

data 'GFXT' (128, "3270toMac", preload) {
/* Standard */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"205B 5DA3 B4D7 D7A7 A4D7 A22E 3C28 2B7C"        /*  []קע.<(+| */
	$"26A1 D7D7 ACAB 2C88 8F93 2124 2A29 3BC2"        /* &׬,!$*); */
	$"2D2F 989D 8B9B D888 8F8E 7C2C 255F 3E3F"        /* -/؈|,%_>? */
	$"9398 9D9F 8D8A 9195 9A60 3A23 4027 3D22"        /* `:#@'=" */
	$"9F61 6263 6465 6667 6869 8990 9499 9E87"        /* abcdefghi */
	$"8E6A 6B6C 6D6E 6F70 7172 9297 9C96 CBD7"        /* jklmnopqr */
	$"D77E 7374 7576 7778 797A D7D7 CC5B D7B5"        /* ~stuvwxyz[׵ */
	$"4545 C0C1 BBA5 BC80 D7D7 8586 D75D D7D7"        /* EEׅ] */
	$"7B41 4243 4445 4647 4849 D7D7 83D7 D7D7"        /* {ABCDEFGHI׃ */
	$"7D4A 4B4C 4D4E 4F50 5152 D7D7 84D7 D7D7"        /* }JKLMNOPQRׄ */
	$"5CCF 5354 5556 5758 595A BF8C 8DD7 D7D7"        /* \STUVWXYZ */
	$"3031 3233 3435 3637 3839 AEAF 8182 D7D1"        /* 0123456789 */
/* APL */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D741 4243 4445 4647 4849 D7D7 D7D7 D7D7"        /* ABCDEFGHI */
	$"D74A 4B4C 4D4E 4F50 5152 D7D7 D7D7 D7D7"        /* JKLMNOPQR */
	$"D7D7 5354 5556 5758 595A D7D7 D7D7 D7D7"        /* STUVWXYZ */
	$"D75E ACD7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /* ^ */
	$"7ED7 D7D7 D7D7 D7D7 D7D7 D7D7 B2D7 D7D7"        /* ~ײ */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 DBD7 B1D7"        /* .ױ */
	$"D7A1 D1A5 6ED7 D7D7 D7D7 D7D7 D75B B3D7"        /* סѥn[ */
	$"D7D7 D7D7 D7D7 D75C D6D7 D7C6 D75D AD7C"        /* \]| */
	$"7BD7 D7D7 D7D7 D7D7 A4D7 D7D7 D7D7 D7D7"        /* {פ */
	$"7DD7 D7D7 D7D7 D7D7 A6D7 D721 D7D7 D7D7"        /* }צ! */
	$"D731 3233 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /* 123 */
	$"3031 3233 3435 3637 3839 D7D7 D7D7 D7D7"        /* 0123456789 */
/* ALA */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7 D7D7"        /*  */
	$"20D7 AFD7 D7AE CED7 D7D7 A22E 3C28 2B7C"        /*  ׯ׮ע.<(+| */
	$"26D7 BFD7 D7BE CFD7 D7FD 2124 2A29 3BC2"        /* &׿׾.!$*); */
	$"2D2F D4D5 E1D7 D7A8 D7B1 7C2C 255F 3E3F"        /* -/.רױ|,%_>? */
	$"3031 3233 3435 3637 3860 3A23 4027 3D22"        /* 012345678`:#@'=" */
	$"D761 6263 6465 6667 6869 A1FA ACD7 D7D7"        /* abcdefghi. */
	$"396A 6B6C 6D6E 6F70 7172 60AB 5EFF D7D7"        /* 9jklmnopqr`^. */
	$"A07E 7374 7576 7778 797A 2B28 D75B 2D29"        /* ~stuvwxyz+([-) */
	$"3031 3233 3435 3637 3839 2B28 D75D 2D29"        /* 0123456789+(]-) */
	$"7B41 4243 4445 4647 4849 D7D7 D7F9 7ED7"        /* {ABCDEFGHI.~ */
	$"7D4A 4B4C 4D4E 4F50 5152 FCD5 D7D7 F8FD"        /* }JKLMNOPQR... */
	$"5CA3 5354 5556 5758 595A FED7 D75F D7D7"        /* \STUVWXYZ._ */
	$"3031 3233 3435 3637 3839 D7A7 D7B4 D7D7"        /* 0123456789ק״ */
};

data 'GFXT' (129, "ALA diacritics", preload) {
	$"C1C5 C9D6 E481 8589 96A4 C3D5 8395 E8A8"        /* .Ճ. */
	$"8C8A DA9B CE9A 9C00 0000 0000 0000 0000"        /* .Κ......... */
	$"80E8 EC85 868A 9195 9A9F 0000 0000 D9D8"        /* ....... */
	$"8100 0000 008C 0000 0000 0000 0000 0000"        /* .............. */
	$"0000 0000 0000 0000 0000 8200 8D00 0000"        /* .............. */
	$"E783 EAEE F287 8E92 979C 0000 0000 0000"        /* .......... */
	$"CC00 00CD 008B 0000 9B00 0084 0096 0000"        /* .......... */
	$"CBE9 EDF1 F488 8F93 989D 0000 0000 0000"        /* .......... */
	$"E5E6 EBEF F389 9094 999E 0000 0000 0000"        /* ........... */
};

data 'VMPR' (128, "WMAC Print Format", preload) {
	$"0016 000B 000C 0084 0004 0039 003B 000E"
	$"0002 000C 0000 004A 0000 0000 0000 0000"
};

resource 'MENU' (234, preload) {
	234,
	textMenuProc,
	allEnabled,
	enabled,
	"National Language",
	{	/* array: 1 element */
		/* [1] */
		"English (U.S.)", noIcon, "", "", plain
	}
};

resource 'MENU' (235, preload) {
	235,
	textMenuProc,
	allEnabled,
	enabled,
	"Key Mapping",
	{	/* array: 0 elements */
	}
};

resource 'MENU' (256, preload) {
	256,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About Mac3270...", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (257, preload) {
	257,
	textMenuProc,
	0x7FFDB56B,
	enabled,
	"File",
	{	/* array: 19 elements */
		/* [1] */
		"New Session", noIcon, "", "", plain,
		/* [2] */
		"End Session", noIcon, "", "", plain,
		/* [3] */
		"-", noIcon, "", "", plain,
		/* [4] */
		"Zoom In", noIcon, "", "", plain,
		/* [5] */
		"-", noIcon, "", "", plain,
		/* [6] */
		"Load Settings...", noIcon, "", "", plain,
		/* [7] */
		"Save Settings...", noIcon, "", "", plain,
		/* [8] */
		"-", noIcon, "", "", plain,
		/* [9] */
		"Set Creator...", noIcon, "", "", plain,
		/* [10] */
		"-", noIcon, "", "", plain,
		/* [11] */
		"Save Graphics", noIcon, "", "", plain,
		/* [12] */
		"-", noIcon, "", "", plain,
		/* [13] */
		"Page Setup...", noIcon, "", "", plain,
		/* [14] */
		"Print Screen...", noIcon, "", "", plain,
		/* [15] */
		"-", noIcon, "", "", plain,
		/* [16] */
		"Interrupt Transfer", noIcon, "", "", plain,
		/* [17] */
		"Show Transfer Status", noIcon, "", "", plain,
		/* [18] */
		"-", noIcon, "", "", plain,
		/* [19] */
		"Quit", noIcon, "Q", "", plain
	}
};

resource 'MENU' (258, preload) {
	258,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 7 elements */
		/* [1] */
		"Undo", noIcon, "Z", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "X", "", plain,
		/* [4] */
		"Copy", noIcon, "C", "", plain,
		/* [5] */
		"Paste", noIcon, "V", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain,
		/* [7] */
		"Copy Table", noIcon, "", "", plain,
		/* [8] */
		"Copy Text", noIcon, "", "", plain
	}
};

resource 'MENU' (259, preload) {
	259,
	textMenuProc,
	allEnabled,
	enabled,
	"Settings",
	{	/* array: 10 elements */
		/* [1] */
		"Features...", noIcon, "", "", plain,
		/* [2] */
		"Double-Click...", noIcon, "", "", plain,
		/* [3] */
		"Highlighting...", noIcon, "", "", plain,
		/* [4] */
		"Colors...", noIcon, "", "", plain,
		/* [5] */
		"Prog. Symbols...", noIcon, "", "", plain,
		/* [6] */
		"Screen Format...", noIcon, "", "", plain,
		/* [7] */
		"Miscellaneous...", noIcon, "", "", plain,
		/* [8] */
		"Host Name...", noIcon, "", "", plain,
		/* [9] */
		"Key Mapping", noIcon, hierarchicalMenu, "\0xeb", plain,
		/* [10] */
		"National Language", noIcon, hierarchicalMenu, "\0xea", plain
	}
};

resource 'MENU' (260, preload) {
	260,
	textMenuProc,
	allEnabled,
	enabled,
	"Function Keys",
	{	/* array: 0 elements */
	}
};

resource 'MENU' (261, preload) {
	261,
	textMenuProc,
	0x7FFFFFEF,
	enabled,
	"Network",
	{	/* array: 11 elements */
		/* [1] */
		"Show Configuration...", noIcon, "", "", plain,
		/* [2] */
		"Connection Status...", noIcon, "", "", plain,
		/* [3] */
		"FTP Enable", noIcon, "", "", plain,
		/* [4] */
		"MacBinary", noIcon, "", "", plain,
		/* [5] */
		"-", noIcon, "", "", plain,
		/* [6] */
		"Send \"Break\"", noIcon, "", "", plain,
		/* [7] */
		"Send \"Interrupt Process\"", noIcon, "", "", plain,
		/* [8] */
		"Send \"Abort Output\"", noIcon, "", "", plain,
		/* [9] */
		"Send \"Are You There?\"", noIcon, "", "", plain,
		/* [10] */
		"Send \"Erase Character\"", noIcon, "", "", plain,
		/* [11] */
		"Send \"Erase Line\"", noIcon, "", "", plain
	}
};

resource 'mstr' (100) {			/* name of menu containing "Quit" */
	"File"
};
	
resource 'mstr' (101) {			/* name of menu item for "Quit" */
	"Quit"
};

resource 'mstr' (102) {			/* name of menu containing "Open" */
	"File"
};

resource 'mstr' (103) {			/* name of menu item for "Open" */
	"Load Settings..."
};

resource 'DLOG' (270, preload) {		/* storage info. */
	{100, 123, 281, 388},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	270,
	"Storage Info."
};

resource 'DLOG' (257, preload) {		/* attrdlg */
	{33, 34, 329, 477},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	257,
	"Choose Attributes"
};

resource 'DLOG' (258, preload) {		/* commdlg (specuser) */
	{40, 45, 303, 467},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	258,
	"Extended Communications"
};

resource 'DLOG' (259, preload) {		/* srvdlg */
	{111, 149, 173, 363},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	259,
	"Looking for server"
};

resource 'DLOG' (260, preload) {		/* featdlg */
	{18, 108, 323, 403},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	260,
	"Features"
};

resource 'DLOG' (261, preload) {		/* savedlg */
	{95, 155, 190, 330},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	261,
	"Save new settings?"
};

resource 'DLOG' (262, preload) {		/* commdlg (!specuser) */
	{106, 46, 236, 466},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	262,
	"Communications"
};

resource 'DLOG' (266, preload) {		/* double-click dialog */
	{50, 76, 244, 437},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	266,
	"Double Click"
};

resource 'DLOG' (267, preload) {
	{61, 57, 175, 456},
	zoomDocProc,
	invisible,
	-1,
	0x0,
	267,
	"RMAC/WMAC Transfer Status"
};

resource 'DLOG' (269, preload) {		/* screen format */
	{41, 84, 301, 429},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	269,
	"Screen Format"
};

resource 'DLOG' (271, preload) {
	{47, 96, 295, 416},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	271,
	"Miscellaneous"
};

resource 'DLOG' (272, preload) {
	{58, 134, 284, 378},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	272,
	"Network Configuration"
};

resource 'DLOG' (273, preload) {
	{44, 134, 297, 378},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	273,
	"Current Configuration"
};

resource 'DLOG' (277, preload) {
	{83, 102, 258, 409},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	277,
	"Connection Status"
};

resource 'DLOG' (280, preload) {
	{116, 148, 226, 363},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	280,
	"Driver Configuration"
};

resource 'DLOG' (302, preload) {
	{126, 130, 214, 372},
	dBoxProc,
	-1,
	-1,
	0x0,
	302,
	"Network Init Bad"
};

resource 'DITL' (270, preload) {
	{	/* array DITLarray: 6 elements */
		/* [1] */
		{142, 88, 165, 172},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 20, 30, 245},
		StaticText {
			disabled,
			""
		},
		/* [3] */
		{35, 20, 55, 245},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{60, 20, 80, 245},
		StaticText {
			disabled,
			""
		},
		/* [5] */
		{85, 20, 105, 245},
		StaticText {
			disabled,
			""
		},
		/* [6] */
		{110, 20, 130, 245},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (257, preload) {
	{	/* array DITLarray: 52 elements */
		/* [1] */
		{250, 321, 277, 381},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{250, 174, 277, 269},
		Button {
			enabled,
			"Set Defaults"
		},
		/* [3] */
		{250, 62, 277, 122},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{15, 222, 34, 322},
		StaticText {
			disabled,
			"Screen Display:"
		},
		/* [5] */
		{40, 10, 56, 90},
		StaticText {
			disabled,
			"3270 Field:"
		},
		/* [6] */
		{65, 10, 81, 60},
		StaticText {
			disabled,
			"default"
		},
		/* [7] */
		{90, 10, 106, 115},
		StaticText {
			disabled,
			"high-intensity"
		},
		/* [8] */
		{115, 10, 131, 90},
		StaticText {
			disabled,
			"non-display"
		},
		/* [9] */
		{140, 10, 156, 65},
		StaticText {
			disabled,
			"reverse"
		},
		/* [10] */
		{165, 10, 181, 45},
		StaticText {
			disabled,
			"blink"
		},
		/* [11] */
		{190, 10, 206, 75},
		StaticText {
			disabled,
			"underline"
		},
		/* [12] */
		{215, 10, 231, 80},
		StaticText {
			disabled,
			"attributes"
		},
		/* [13] */
		{40, 112, 56, 192},
		StaticText {
			disabled,
			"non-display"
		},
		/* [14] */
		{40, 206, 56, 249},
		StaticText {
			disabled,
			"frame"
		},
		/* [15] */
		{40, 260, 56, 315},
		StaticText {
			disabled,
			"reverse"
		},
		/* [16] */
		{40, 320, 56, 387},
		StaticText {
			disabled,
			"underline"
		},
		/* [17] */
		{40, 396, 56, 433},
		StaticText {
			disabled,
			"bold"
		},
		/* [18] */
		{65, 145, 81, 159},
		CheckBox {
			enabled,
			""
		},
		/* [19] */
		{65, 220, 81, 234},
		CheckBox {
			enabled,
			""
		},
		/* [20] */
		{65, 280, 81, 294},
		CheckBox {
			enabled,
			""
		},
		/* [21] */
		{65, 346, 81, 360},
		CheckBox {
			enabled,
			""
		},
		/* [22] */
		{65, 405, 81, 419},
		CheckBox {
			enabled,
			""
		},
		/* [23] */
		{90, 145, 106, 159},
		CheckBox {
			enabled,
			""
		},
		/* [24] */
		{90, 220, 106, 234},
		CheckBox {
			enabled,
			""
		},
		/* [25] */
		{90, 280, 106, 294},
		CheckBox {
			enabled,
			""
		},
		/* [26] */
		{90, 346, 106, 360},
		CheckBox {
			enabled,
			""
		},
		/* [27] */
		{90, 405, 106, 419},
		CheckBox {
			enabled,
			""
		},
		/* [28] */
		{115, 145, 131, 159},
		CheckBox {
			enabled,
			""
		},
		/* [29] */
		{115, 220, 131, 234},
		CheckBox {
			enabled,
			""
		},
		/* [30] */
		{115, 280, 131, 294},
		CheckBox {
			enabled,
			""
		},
		/* [31] */
		{115, 346, 131, 360},
		CheckBox {
			enabled,
			""
		},
		/* [32] */
		{115, 405, 131, 419},
		CheckBox {
			enabled,
			""
		},
		/* [33] */
		{140, 145, 156, 159},
		CheckBox {
			enabled,
			""
		},
		/* [34] */
		{140, 220, 156, 234},
		CheckBox {
			enabled,
			""
		},
		/* [35] */
		{140, 280, 156, 294},
		CheckBox {
			enabled,
			""
		},
		/* [36] */
		{140, 346, 156, 360},
		CheckBox {
			enabled,
			""
		},
		/* [37] */
		{140, 405, 156, 419},
		CheckBox {
			enabled,
			""
		},
		/* [38] */
		{165, 145, 181, 159},
		CheckBox {
			enabled,
			""
		},
		/* [39] */
		{165, 220, 181, 234},
		CheckBox {
			enabled,
			""
		},
		/* [40] */
		{165, 280, 181, 294},
		CheckBox {
			enabled,
			""
		},
		/* [41] */
		{165, 346, 181, 360},
		CheckBox {
			enabled,
			""
		},
		/* [42] */
		{165, 405, 181, 419},
		CheckBox {
			enabled,
			""
		},
		/* [43] */
		{190, 145, 206, 159},
		CheckBox {
			enabled,
			""
		},
		/* [44] */
		{190, 220, 206, 234},
		CheckBox {
			enabled,
			""
		},
		/* [45] */
		{190, 280, 206, 294},
		CheckBox {
			enabled,
			""
		},
		/* [46] */
		{190, 346, 206, 360},
		CheckBox {
			enabled,
			""
		},
		/* [47] */
		{190, 405, 206, 419},
		CheckBox {
			enabled,
			""
		},
		/* [48] */
		{215, 145, 231, 159},
		CheckBox {
			enabled,
			""
		},
		/* [49] */
		{215, 220, 231, 234},
		CheckBox {
			enabled,
			""
		},
		/* [50] */
		{215, 280, 231, 294},
		CheckBox {
			enabled,
			""
		},
		/* [51] */
		{215, 346, 231, 360},
		CheckBox {
			enabled,
			""
		},
		/* [52] */
		{215, 405, 231, 419},
		CheckBox {
			enabled,
			""
		}
	}
};

resource 'DITL' (258, preload) {
	{	/* array DITLarray: 16 elements */
		/* [1] */
		{212, 295, 244, 380},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{212, 155, 244, 260},
		Button {
			enabled,
			"Set Defaults"
		},
		/* [3] */
		{212, 40, 244, 120},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{133, 10, 151, 88},
		StaticText {
			disabled,
			"Host name:"
		},
		/* [5] */
		{123, 95, 159, 402},
		EditText {
			enabled,
			""
		},
		/* [6] */
		{15, 10, 31, 125},
		StaticText {
			disabled,
			"Connection type:"
		},
		/* [7] */
		{172, 58, 201, 356},
		CheckBox {
			enabled,
			"Connect to host when settings are loaded"
		},
		/* [8] */
		{15, 140, 31, 220},
		RadioButton {
			enabled,
			"AppleTalk"
		},
		/* [9] */
		{15, 240, 31, 300},
		RadioButton {
			enabled,
			"Serial"
		},
		/* [10] */
		{15, 315, 31, 379},
		RadioButton {
			enabled,
			"TCP/IP"
		},
		/* [11] */
		{49, 10, 65, 130},
		StaticText {
			disabled,
			"Timeout seconds:"
		},
		/* [12] */
		{49, 142, 65, 162},
		EditText {
			enabled,
			""
		},
		/* [13] */
		{49, 235, 65, 320},
		StaticText {
			disabled,
			"Retry count:"
		},
		/* [14] */
		{49, 329, 65, 349},
		EditText {
			enabled,
			""
		},
		/* [15] */
		{85, 10, 101, 93},
		StaticText {
			disabled,
			"Debug level:"
		},
		/* [16] */
		{85, 142, 101, 162},
		EditText {
			enabled,
			""
		}
	}
};

resource 'DITL' (259, preload) {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{23, 26, 39, 188},
		StaticText {
			disabled,
			"Looking for 3270 server"
		}
	}
};

resource 'DITL' (260, preload) {
	{	/* array DITLarray: 21 elements */
		/* [1] */
		{265, 224, 293, 285},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{15, 10, 52, 165},
		StaticText {
			disabled,
			"Reset insert mode after attention keys:"
		},
		/* [3] */
		{25, 185, 41, 230},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [4] */
		{25, 245, 41, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [5] */
		{55, 10, 92, 165},
		StaticText {
			disabled,
			"Discard trailing blanks in insert mode:"
		},
		/* [6] */
		{65, 185, 81, 230},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [7] */
		{65, 245, 81, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [8] */
		{95, 10, 132, 165},
		StaticText {
			disabled,
			"Change embedded nulls to blanks:"
		},
		/* [9] */
		{105, 186, 121, 231},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [10] */
		{105, 245, 121, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [11] */
		{135, 10, 172, 165},
		StaticText {
			disabled,
			"Use Command Shift <digit> for PF keys:"
		},
		/* [12] */
		{145, 186, 161, 231},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [13] */
		{145, 245, 161, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [14] */
		{175, 10, 212, 165},
		StaticText {
			disabled,
			"Support 3270 extended data stream:"
		},
		/* [15] */
		{185, 186, 201, 231},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [16] */
		{185, 245, 201, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [17] */
		{215, 10, 252, 165},
		StaticText {
			disabled,
			"Treat \"[\" and \"]\" as standard characters"
			":"
		},
		/* [18] */
		{225, 186, 241, 231},
		RadioButton {
			enabled,
			"Yes"
		},
		/* [19] */
		{225, 245, 241, 285},
		RadioButton {
			enabled,
			"No"
		},
		/* [20] */
		{265, 109, 293, 200},
		Button {
			enabled,
			"Set Defaults"
		},
		/* [21] */
		{265, 10, 293, 85},
		Button {
			enabled,
			"Cancel"
		}
	}
};

resource 'DITL' (261, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{50, 15, 72, 75},
		Button {
			enabled,
			"YES"
		},
		/* [2] */
		{50, 95, 72, 155},
		Button {
			enabled,
			"NO"
		},
		/* [3] */
		{20, 15, 41, 150},
		StaticText {
			disabled,
			"Save new settings?"
		}
	}
};

resource 'DITL' (262, preload) {
	{	/* array DITLarray: 7 elements */
		/* [1] */
		{91, 336, 117, 400},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{91, 225, 117, 316},
		Button {
			enabled,
			"Set Default"
		},
		/* [3] */
		{91, 21, 117, 83},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{22, 9, 41, 86},
		StaticText {
			disabled,
			"Host name:"
		},
		/* [5] */
		{12, 93, 48, 405},
		EditText {
			enabled,
			""
		},
		/* [6] */
		{91, 102, 117, 205},
		Button {
			enabled,
			"Make Default"
		},
		/* [7] */
		{58, 52, 84, 349},
		CheckBox {
			enabled,
			"Connect to host when settings are loaded"
		}
	}
};

resource 'DITL' (263, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{52, 71, 76, 127},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{19, 72, 35, 182},
		StaticText {
			disabled,
			"Out of memory!"
		}
	}
};

resource 'DITL' (264) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 140, 114, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DITL' (265, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{16, 160, 36, 240},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{60, 30, 150, 260},
		StaticText {
			disabled,
			"The file '^0' is ^1K too large to fit on"
			" '^2'."
		}
	}
};

resource 'DITL' (266, preload) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{148, 271, 177, 352},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{148, 133, 177, 227},
		Button {
			enabled,
			"Set Default"
		},
		/* [3] */
		{148, 9, 177, 84},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{10, 9, 111, 352},
		UserItem {
			enabled
		},
		/* [5] */
		{121, 91, 139, 270},
		StaticText {
			disabled,
			"Mouse Double-Click Action"
		}
	}
};

resource 'DITL' (267) {
	{	/* array DITLarray: 7 elements */
		/* [1] */
		{4, 5, 38, 394},
		StaticText {
			disabled,
			""
		},
		/* [2] */
		{45, 5, 61, 168},
		StaticText {
			disabled,
			"Characters transferred:"
		},
		/* [3] */
		{45, 173, 61, 394},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{68, 5, 84, 163},
		StaticText {
			disabled,
			"Characters per second:"
		},
		/* [5] */
		{68, 168, 84, 394},
		StaticText {
			disabled,
			""
		},
		/* [6] */
		{91, 5, 107, 185},
		StaticText {
			disabled,
			"Estimated time remaining:"
		},
		/* [7] */
		{91, 190, 107, 270},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (268, preload) {
	{	/* array DITLarray: 27 elements */
		/* [1] */
		{66, 285, 96, 345},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{111, 265, 141, 365},
		Button {
			enabled,
			"Set Defaults"
		},
		/* [3] */
		{156, 275, 186, 355},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{15, 252, 51, 378},
		StaticText {
			disabled,
			"To change a color, click on it."
		},
		/* [5] */
		{5, 5, 25, 100},
		UserItem {
			enabled
		},
		/* [6] */
		{8, 105, 23, 175},
		StaticText {
			enabled,
			"white"
		},
		/* [7] */
		{35, 5, 55, 100},
		UserItem {
			enabled
		},
		/* [8] */
		{38, 105, 53, 175},
		StaticText {
			enabled,
			"yellow"
		},
		/* [9] */
		{65, 5, 85, 100},
		UserItem {
			enabled
		},
		/* [10] */
		{68, 105, 83, 175},
		StaticText {
			enabled,
			"turquoise"
		},
		/* [11] */
		{95, 5, 115, 100},
		UserItem {
			enabled
		},
		/* [12] */
		{98, 105, 113, 175},
		StaticText {
			enabled,
			"green"
		},
		/* [13] */
		{125, 5, 145, 100},
		UserItem {
			enabled
		},
		/* [14] */
		{128, 105, 143, 175},
		StaticText {
			enabled,
			"pink"
		},
		/* [15] */
		{155, 5, 175, 100},
		UserItem {
			enabled
		},
		/* [16] */
		{158, 105, 173, 175},
		StaticText {
			enabled,
			"red"
		},
		/* [17] */
		{185, 5, 205, 100},
		UserItem {
			enabled
		},
		/* [18] */
		{188, 105, 203, 175},
		StaticText {
			enabled,
			"blue"
		},
		/* [19] */
		{215, 5, 235, 100},
		UserItem {
			enabled
		},
		/* [20] */
		{218, 105, 233, 175},
		StaticText {
			enabled,
			"black"
		},
		/* [21] */
		{245, 5, 265, 100},
		UserItem {
			enabled
		},
		/* [22] */
		{248, 105, 263, 186},
		StaticText {
			enabled,
			"background"
		},
		/* [23] */
		{275, 5, 295, 100},
		UserItem {
			enabled
		},
		/* [24] */
		{278, 105, 293, 186},
		StaticText {
			enabled,
			"status line"
		},
		/* [25] */
		{246, 235, 266, 363},
		CheckBox {
			enabled,
			"base color mode"
		},
		/* [26] */
		{216, 235, 236, 341},
		CheckBox {
			enabled,
			"exact colors"
		},
		/* [27] */
		{276, 235, 296, 405},
		CheckBox {
			enabled,
			"invert black and white"
		}
	}
};

resource 'DITL' (269, preload) {		/* screen format */
	{	/* array DITLarray: 22 elements */
		/* [1] */
		{218, 265, 242, 335},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{218, 10, 242, 100},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{218, 130, 242, 230},
		Button {
			enabled,
			"Set Defaults"
		},
		/* [4] */
		{10, 10, 25, 182},
		StaticText {
			disabled,
			"24-by-80 Screen Format:"
		},
		/* [5] */
		{35, 10, 51, 90},
		RadioButton {
			enabled,
			"9-point"
		},
		/* [6] */
		{35, 120, 51, 200},
		RadioButton {
			enabled,
			"12-point"
		},
		/* [7] */
		{168, 10, 186, 284},
		CheckBox {
			enabled,
			"Use one window size for both formats"
		},
		/* [8] */
		{188, 10, 206, 267},
		CheckBox {
			enabled,
			"Save window position with settings"
		},
		/* [9] */
		{60, 10, 75, 158},
		StaticText {
			disabled,
			"Large Screen Format:"
		},
		/* [10] */
		{85, 10, 101, 90},
		RadioButton {
			enabled,
			"9-point"
		},
		/* [11] */
		{105, 10, 121, 90},
		RadioButton {
			enabled,
			"12-point"
		},
		/* [12] */
		{85, 120, 101, 200},
		RadioButton {
			enabled,
			"24 by 80"
		},
		/* [13] */
		{105, 120, 121, 200},
		RadioButton {
			enabled,
			"32 by 80"
		},
		/* [14] */
		{125, 120, 141, 200},
		RadioButton {
			enabled,
			"43 by 80"
		},
		/* [15] */
		{145, 120, 161, 205},
		RadioButton {
			enabled,
			"27 by 132"
		},
		/* [16] */
		{85, 215, 101, 285},
		RadioButton {
			enabled,
			"Custom"
		},
		/* [17] */
		{109, 235, 125, 275},
		StaticText {
			disabled,
			"Rows"
		},
		/* [18] */
		{109, 280, 125, 315},
		EditText {
			enabled,
			""
		},
		/* [19] */
		{108, 321, 126, 332},
		UserItem {
			enabled
		},
		/* [20] */
		{130, 215, 146, 275},
		StaticText {
			disabled,
			"Columns"
		},
		/* [21] */
		{130, 280, 146, 315},
		EditText {
			enabled,
			""
		},
		/* [22] */
		{129, 321, 147, 332},
		UserItem {
			enabled
		}
	}
};

resource 'DITL' (271, preload) {
	{	/* array DITLarray: 14 elements */
		/* [1] */
		{198, 218, 232, 298},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{137, 218, 171, 298},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{15, 15, 32, 54},
		StaticText {
			disabled,
			"Time:"
		},
		/* [4] */
		{14, 70, 31, 145},
		RadioButton {
			enabled,
			"12-hour"
		},
		/* [5] */
		{14, 161, 31, 236},
		RadioButton {
			enabled,
			"24-hour"
		},
		/* [6] */
		{14, 252, 31, 305},
		RadioButton {
			enabled,
			"none"
		},
		/* [7] */
		{49, 15, 66, 67},
		StaticText {
			disabled,
			"Cursor:"
		},
		/* [8] */
		{48, 83, 65, 165},
		RadioButton {
			enabled,
			"underline"
		},
		/* [9] */
		{48, 181, 65, 236},
		RadioButton {
			enabled,
			"block"
		},
		/* [10] */
		{83, 15, 100, 124},
		StaticText {
			disabled,
			"Cursor position:"
		},
		/* [11] */
		{82, 140, 99, 182},
		RadioButton {
			enabled,
			"off"
		},
		/* [12] */
		{82, 198, 99, 235},
		RadioButton {
			enabled,
			"on"
		},
		/* [13] */
		{117, 15, 135, 100},
		UserItem {
			disabled
		},
		/* [14] */
		{138, 15, 234, 194},
		UserItem {
			enabled
		}
	}
};

resource 'DITL' (272, preload) {
	{	/* array DITLarray: 9 elements */
		/* [1] */
		{171, 82, 201, 163},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{46, 13, 62, 113},
		RadioButton {
			enabled,
			"IP number:"
		},
		/* [3] */
		{46, 111, 62, 231},
		EditText {
			enabled,
			""
		},
		/* [4] */
		{72, 13, 91, 158},
		RadioButton {
			enabled,
			"Assign dynamically"
		},
		/* [5] */
		{104, 13, 121, 138},
		CheckBox {
			enabled,
			"Use subnetting"
		},
		/* [6] */
		{128, 30, 144, 75},
		StaticText {
			disabled,
			"Mask:"
		},
		/* [7] */
		{128, 80, 145, 150},
		EditText {
			enabled,
			""
		},
		/* [8] */
		{13, 16, 29, 228},
		StaticText {
			disabled,
			"Configure Network Parameters"
		},
		/* [9] */
		{74, 162, 93, 208},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (273, preload) {
	{	/* array DITLarray: 13 elements */
		/* [1] */
		{204, 82, 234, 163},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{94, 13, 110, 113},
		StaticText {
			disabled,
			"IP number:"
		},
		/* [3] */
		{94, 101, 110, 221},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{120, 13, 139, 174},
		CheckBox {
			disabled,
			"Assigned dynamically"
		},
		/* [5] */
		{147, 13, 164, 138},
		CheckBox {
			disabled,
			"Use subnetting"
		},
		/* [6] */
		{169, 30, 185, 75},
		StaticText {
			disabled,
			"Mask:"
		},
		/* [7] */
		{169, 80, 185, 150},
		StaticText {
			disabled,
			""
		},
		/* [8] */
		{10, 16, 26, 228},
		StaticText {
			disabled,
			"Current Network Parameters:"
		},
		/* [9] */
		{39, 13, 55, 117},
		StaticText {
			disabled,
			"AppleTalk Net:"
		},
		/* [10] */
		{39, 117, 55, 221},
		StaticText {
			disabled,
			""
		},
		/* [11] */
		{67, 13, 82, 127},
		StaticText {
			disabled,
			"AppleTalk Node: "
		},
		/* [12] */
		{67, 127, 82, 221},
		StaticText {
			disabled,
			""
		},
		/* [13] */
		{122, 178, 141, 224},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (274) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{112, 164, 144, 244},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 72, 47, 343},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{58, 72, 98, 343},
		StaticText {
			disabled,
			"^1"
		}
	}
};

resource 'DITL' (275) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{112, 164, 144, 244},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 72, 47, 343},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{58, 72, 98, 343},
		StaticText {
			disabled,
			"^1"
		}
	}
};

resource 'DITL' (276) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{112, 164, 144, 244},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 72, 47, 343},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{58, 72, 98, 343},
		StaticText {
			disabled,
			"^1"
		}
	}
};

resource 'DITL' (277, preload) {
	{	/* array DITLarray: 7 elements */
		/* [1] */
		{123, 113, 155, 193},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{9, 10, 25, 90},
		StaticText {
			disabled,
			"Host Name:"
		},
		/* [3] */
		{9, 90, 44, 300},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{50, 12, 66, 90},
		StaticText {
			disabled,
			"IP number:"
		},
		/* [5] */
		{50, 90, 66, 218},
		StaticText {
			disabled,
			""
		},
		/* [6] */
		{75, 38, 91, 90},
		StaticText {
			disabled,
			"Status:"
		},
		/* [7] */
		{75, 90, 110, 300},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (278, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 140, 114, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DITL' (279, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{76, 151, 108, 237},
		Button {
			enabled,
			"Continue"
		},
		/* [2] */
		{124, 123, 156, 265},
		Button {
			enabled,
			"Close Connection"
		},
		/* [3] */
		{9, 67, 60, 321},
		StaticText {
			disabled,
			"Do you want to close the connection to ^0?"
		}
	}
};

resource 'DITL' (280, preload) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{68, 66, 97, 148},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{11, 32, 30, 184},
		StaticText {
			disabled,
			"Configured via MacTCP"
		},
		/* [3] */
		{38, 11, 54, 86},
		StaticText {
			disabled,
			"IP Number:"
		},
		/* [4] */
		{38, 90, 54, 203},
		StaticText {
			disabled,
			""
		}
	}
};

resource 'DITL' (281, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 140, 114, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DITL' (282, preload) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{66, 244, 94, 328},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{66, 41, 94, 125},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{10, 9, 44, 124},
		StaticText {
			enabled,
			"Enter host name or address:"
		},
		/* [4] */
		{10, 140, 46, 360},
		EditText {
			enabled,
			""
		}
	}
};

resource 'DITL' (283, preload) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{87, 146, 109, 195},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{49, 40, 71, 195},
		Button {
			enabled,
			"Get From Application"
		},
		/* [3] */
		{87, 40, 109, 111},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{18, 13, 37, 163},
		StaticText {
			disabled,
			"Creator for text files:"
		},
		/* [5] */
		{18, 165, 34, 217},
		EditText {
			enabled,
			""
		}
	}
};

resource 'DITL' (284, preload) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{53, 125, 75, 174},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{53, 15, 75, 86},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{15, 13, 33, 30},
		CheckBox {
			enabled,
			"Check Box"
		},
		/* [4] */
		{9, 34, 46, 182},
		StaticText {
			enabled,
			"Pretend to support programmed symbols"
		}
	}
};

resource 'DITL' (302, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{3, 19, 23, 226},
		StaticText {
			enabled,
			"Network Initialization Failed!"
		},
		/* [2] */
		{27, 18, 72, 224},
		StaticText {
			enabled,
			"^3"
		}
	}
};

resource 'ALRT' (263, preload) {		/* stgalert */
	{69, 155, 164, 357},
	263,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'ALRT' (264, preload) {		/* stoperr */
	{88, 76, 214, 436},
	264,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'ALRT' (265, preload) {
	{120, 120, 240, 400},
	265,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'ALRT' (274, preload) {		/* tcp stop */
	{100, 101, 251, 465},
	274,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'ALRT' (275, preload) {		/* tcp caution */
	{100, 101, 251, 465},
	274,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound2,
		/* [2] */
		OK, visible, sound2,
		/* [3] */
		OK, visible, sound2,
		/* [4] */
		OK, visible, sound2
	}
};

resource 'ALRT' (276, preload) {		/* tcp note */
	{100, 101, 251, 465},
	274,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'ALRT' (278, preload) {		/* note_err for mapalrt only */
	{88, 76, 214, 436},
	278,
	{	/* array: 4 elements */
		/* [1] */
		OK, invisible, silent,
		/* [2] */
		OK, invisible, silent,
		/* [3] */
		OK, invisible, silent,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'ALRT' (279, preload) {
	{82, 83, 260, 429},
	279,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound2,
		/* [2] */
		OK, visible, sound2,
		/* [3] */
		OK, visible, sound2,
		/* [4] */
		OK, visible, sound2
	}
};

resource 'ALRT' (281, preload) {		/* note_err for all but mapalrt */
	{88, 76, 214, 436},
	281,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound2,
		/* [2] */
		OK, visible, sound2,
		/* [3] */
		OK, visible, sound2,
		/* [4] */
		OK, visible, sound2
	}
};

resource 'DLOG' (282, preload) {		/* host name prompt */
	{114, 71, 228, 441},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	282,
	"Host name prompt"
};

resource 'DLOG' (283, preload) {
	{109, 139, 233, 373},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	283,
	"Set File Creator"
};

resource 'DLOG' (284, preload) {
	{125, 158, 216, 354},
	altDBoxProc,
	invisible,
	noGoAway,
	0x0,
	284,
	"Programmed Symbols"
};

resource 'STR ' (256, preload) {				/* portalrt */
	"The printer port is not available for us"
	"e by AppleTalk.  Check that AppleTalk is"
	" active in the Chooser desk accessory."
};

resource 'STR ' (257, preload) {				/* loadalrt */
	"Unable to load AppleTalk drivers.  A new"
	" System file may be needed."
};

resource 'STR ' (258, preload) {				/* srvalrt */
	"Session not available on local server.  "
	"The AppleTalk connection to a server is "
	"broken, no server is running, or all loc"
	"al sessions are in use."
};

resource 'STR ' (259, preload) {				/* atpalrt */
	"Attempt to open AppleTalk socket failed."
	"  Too many AppleTalk programs may be run"
	"ning at once."
};

resource 'STR ' (260, preload) {				/* rmtalrt */
	"Remote server is not available.  There i"
	"s a problem with the remote host, the re"
	"mote server, or the network connection t"
	"o it."
};

resource 'STR ' (261, preload) {				/* nackalrt */
	"Session disconnected by local server.  T"
	"he server was restarted, or there has be"
	"en an AppleTalk error."
};
	
resource 'STR ' (262, preload) {				/* ioalrt */
	"Session disconnected due to AppleTalk or"
	" server error.  There is a problem with "
	"the local server or the AppleTalk connec"
	"tion to it."
};

resource 'STR ' (263, preload) {				/* rsetalrt */
	"An error occurred reading the settings f"
	"ile.  The settings remain unchanged."
};

resource 'STR ' (264, preload) {				/* ssetalrt */
	"The format of the settings file is incor"
	"rect.  The settings remain unchanged."
};

resource 'STR ' (265, preload) {				/* wsetalrt */
	"An error occurred writing the settings f"
	"ile. Check that the disk is not locked o"
	"r full."
};

resource 'STR ' (266, preload) {				/* addralrt */
	"Unable to determine my IP number and mas"
	"k.  "
};

resource 'STR ' (267, preload) {				/* regalrt */
	"Unable to register my IP number."
};

resource 'STR ' (268, preload) {				/* cfigalrt */
	"An error occurred saving the network con"
	"figuration data.  Check that the disk is"
	" not locked or full."
};

resource 'STR ' (269, preload) {				/* domalrt */
	"Cannot determine host address.  Table lo"
	"okup failed, and name server not specifi"
	"ed."
};

resource 'STR ' (270, preload) {				/* topnalrt */
	"Attempt to open telnet connection failed"
	"."
};

resource 'STR ' (271, preload) {				/* conalrt */
	"Cannot connect to host.  Host is unreach"
	"able or there is a network problem."
};

resource 'STR ' (272, preload) {				/* rspalrt */
	"Host or gateway not responding.  Session"
	" ended."
};

resource 'STR ' (273, preload) {				/* numalrt */
	"Unable to determine host address: table "
	"and name server lookups failed."
};

resource 'STR ' (274, preload) {				/* negalrt */
	"Host does not support a 3270 Telnet sess"
	"ion."
};

resource 'STR ' (275, preload) {				/* wrtalrt */
	"Unable to send data to host.  Session en"
	"ded."
};

resource 'STR ' (276, preload) {				/* et1alrt */
	"Couldn't install Listener."
};

resource 'STR ' (277, preload) {				/* et2alrt */
	"Couldn't find atpl resource."
};

resource 'STR ' (278, preload) {				/* et3alrt */
	"Unkown error initializing EtherTalk."
};

resource 'STR ' (279, preload) {				/* mapalrt */
	"Not enough memory for text bitmap -- "
	"increase memory size to avoid flickering.  "
	"See About box for memory requirements."
};

resource 'STR ' (280, preload) {				/* wpictalrt */
	"An error occurred writing the graphics f"
	"ile. Check that the disk is not locked o"
	"r full."
};

resource 'STR ' (281, preload) {				/* kbdefalrt */
	"Unable to load the default keyboard mapping resource."
};

resource 'STR ' (282, preload) {				/* kbsetalrt */
	"The keyboard mapping in the settings file is "
	"not available.  The current mapping will "
	"continue to be used."
};

resource 'STR ' (283, preload) {				/* nlsetalrt */
	"The national language in the settings file is "
	"not available.  The current language will "
	"continue to be used."
};

resource 'STR ' (284, preload) {				/* fmtalrt */
	"The screen format settings are incompatible with "
	"the screen size.  The settings have been adjusted "
	"to fit the screen."
};

resource 'STR ' (285, preload) {				/* hostfalrt */
	"Unable to locate the configuration file \"config.tel\". "
	"Please locate it using the following dialog."
};

resource 'STR ' (286, preload) {				/* sdsetalrt */
	"The beep sound named in the settings file is "
	"not available.  The system alert sound will be used."
};

resource 'STR ' (287, preload) {				/* sdmemalrt */
	"Not enough memory is available to define the new beep sound.  "
	"The beep sound will remain unchanged."
};

resource 'STR ' (288, preload) {				/* newwindalrt */
	"Not enough memory is available to create a new window.  "
	"Increase the memory available, or reduce the window size."
};

resource 'STR ' (289, preload) {				/* windfmtalrt */
	"Screen format changes with a new screen size take effect "
	"the next time a new session is established."
};

resource 'STR ' (290, preload) {				/* apinalrt */
	"tn3270 SPPC API cannot be used: all available names "
	"are already in use."
};

resource 'STR ' (291, preload) {				/* apisalrt */	
	"tn3270 SPPC API cannot be used: insufficient memory available."
};

resource 'STR ' (292, preload) {				/* pnumalrt */	
	"The port number specification is incorrect.  The default Telnet "
	"port will be used to open the connection."
};

resource 'STR ' (293, preload) {				/* ppcinitalrt */	
	"tn3270 PPC API cannot be used: initialization of PPC failed."
};

resource 'STR ' (294, preload) {				/* ppcnamealrt */	
	"tn3270 PPC API cannot be used: all available names "
	"are already in use."
};

resource 'STR ' (295, preload) {				/* ppcopenalrt */	
	"tn3270 PPC API cannot be used: unable to open a port "
	"for the session manger."
};

resource 'STR ' (300, preload) {
	"The input file cannot be found."
};

resource 'STR ' (301, preload) {
	"An error has occurred reading the input "
	"file."
};

resource 'STR ' (302, preload) {
	"The input file contains non- printable c"
	"haracters which cannot be transferred.  "
	"They have been translated to the | chara"
	"cter."
};

resource 'STR ' (303, preload) {
	"The output file cannot be created. Check"
	" that the disk is not locked or already "
	"full."
};

resource 'STR ' (304, preload) {
	"An error has occurred writing the output"
	" file. The disk is probably full."
};

resource 'STR ' (305, preload) {
	"An error occurred during printing."
};
