/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.4d7  April, 1992
 *  Copyright (c) 1988, 1989, 1990, 1991, 1992 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Types.r"
#include "SysTypes.r"

#define the_datestr "December 17, 1991"
#define the_majorver 0x2
#define the_minorver 0x4
#define the_stage alpha
#define the_build 0x2
#define the_verstr "2.4a2"

type 'GFTK' {
		pstring;
};

resource 'GFTK' (0, preload) {
	"KeyMap (for tn3270) by Peter DiCamillo Version "
	the_verstr "  " the_datestr
};

resource 'vers' (1, preload) {
	the_majorver,
	the_minorver,
	the_stage,
	the_build,
	verUs,
	the_verstr,
	the_verstr " " the_datestr
};

resource 'SIZE' (-1) {
	reserved,
	ignoreSuspendResumeEvents,
	reserved,
	cannotBackground,
	notMultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	102400,
	102400
};

resource 'FREF' (12325) {
	'APPL',
	0,
	""
};

resource 'BNDL' (12325) {
	'GFTK',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 element */
			/* [1] */
			0, 12325
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 element */
			/* [1] */
			0, 12325
		}
	}
};

resource 'FREF' (12325) {
	'APPL',
	0,
	""
};

resource 'MENU' (256, preload) {
	256,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"About KeyMap...", noIcon, "", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain
	}
};

resource 'MENU' (257, preload) {
	257,
	textMenuProc,
	allEnabled,
	enabled,
	"File",
	{	/* array: 6 elements */
		/* [1] */
		"Open definition file", noIcon, "", "", plain,
		/* [2] */
		"Show definition info", noIcon, "", "", plain,
		/* [3] */
		"Write Rez text file", noIcon, "", "", plain,
		/* [4] */
		"Write resource to existing file", noIcon, "", "", plain,
		/* [5] */
		"Write resource to new file", noIcon, "", "", plain,
		/* [6] */
		"Quit", noIcon, "", "", plain
	}
};

resource 'MENU' (258, preload) {
	258,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Undo", noIcon, "Z", "", plain,
		/* [2] */
		"-", noIcon, "", "", plain,
		/* [3] */
		"Cut", noIcon, "X", "", plain,
		/* [4] */
		"Copy", noIcon, "C", "", plain,
		/* [5] */
		"Paste", noIcon, "V", "", plain,
		/* [6] */
		"Clear", noIcon, "", "", plain
	}
};

resource 'ALRT' (256, preload) {
	{88, 76, 214, 436},
	256,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'DITL' (256, preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{82, 140, 114, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		}
	}
};

resource 'DLOG' (257, preload) {
	{86, 96, 256, 416},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	257,
	""
};

resource 'DITL' (257, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{122, 119, 157, 202},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{13, 25, 54, 296},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{63, 21, 113, 296},
		StaticText {
			disabled,
			"Use KeyMap to define a new keyboard "
			"mapping for tn3270 from a definition file."
		}
	}
};

resource 'DLOG' (258, preload) {
	{100, 100, 249, 364},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	258,
	""
};

resource 'DITL' (258, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{100, 157, 127, 237},
		Button {
			enabled,
			"Cancel"
		},
		/* [2] */
		{100, 26, 127, 106},
		Button {
			enabled,
			"Replace"
		},
		/* [3] */
		{16, 17, 71, 246},
		StaticText {
			disabled,
			"Replace the existing map resource named "
			"\"^0\"?"
		}
	}
};

resource 'DLOG' (259, preload) {
	{100, 100, 376, 438},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	259,
	""
};

resource 'DITL' (259, preload) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{225, 131, 257, 210},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{21, 13, 56, 327},
		StaticText {
			disabled,
			"File: ^0"
		},
		/* [3] */
		{75, 13, 110, 327},
		StaticText {
			disabled,
			"Last Modified: ^1"
		},
		/* [4] */
		{129, 13, 166, 327},
		StaticText {
			disabled,
			"Resource map name: ^2"
		},
		/* [5] */
		{183, 13, 202, 327},
		StaticText {
			disabled,
			"Rez file resource number: ^3"
		}
	}
};

resource 'ALRT' (260, preload) {
	{51, 76, 251, 436},
	260,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound3,
		/* [3] */
		OK, visible, sound3,
		/* [4] */
		OK, visible, sound3
	}
};

resource 'DITL' (260, preload) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{156, 140, 188, 220},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{8, 72, 74, 332},
		StaticText {
			disabled,
			"^0"
		},
		/* [3] */
		{82, 72, 148, 332},
		StaticText {
			disabled,
			"^1"
		}
	}
};

resource 'ICN#' (12325) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFDF FBFF 8050 0A01 8C53 8A71 9252 4A89"
		$"9253 8A81 9E52 4A81 9252 4A89 9253 8A71"
		$"8050 0A01 FFDF FBFF 0000 0000 FFDF FBFF"
		$"8050 0A01 8051 0A11 8053 8AF9 BE57 CA21"
		$"8251 0AF9 8251 0A41 8051 0A01 8050 0A01"
		$"FFDF FBFF 0000 0000 FFDF FBFF 8050 0A01"
		$"8051 0A01 8851 0A11 9851 0A19 BF57 CAFD"
		$"9853 8A19 8851 0A11 8050 0A01 FFDF FBFF",
		/* [2] */
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF 0000 0000 FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF 0000 0000 FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
		$"FFDF FBFF FFDF FBFF FFDF FBFF FFDF FBFF"
	}
};

resource 'ics#' (12325) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 7BDE 7B52 4B5E 7BDE 0000 7BDE 5BD6"
		$"5A5A 7BDE 0000 7BDE 6A56 6BD6 7BDE",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'icl8' (12325) {
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 D2D2 F6F6 F6FF 00FF F6F6 D2D2"
	$"D2F6 F6F6 FF00 FFF6 F6D2 D2D2 F6F6 F6FF"
	$"FFF6 F6D2 F6F6 D2F6 F6FF 00FF F6F6 D2F6"
	$"F6D2 F6F6 FF00 FFF6 D2F6 F6F6 D2F6 F6FF"
	$"FFF6 F6D2 F6F6 D2F6 F6FF 00FF F6F6 D2D2"
	$"D2F6 F6F6 FF00 FFF6 D2F6 F6F6 F6F6 F6FF"
	$"FFF6 F6D2 D2D2 D2F6 F6FF 00FF F6F6 D2F6"
	$"F6D2 F6F6 FF00 FFF6 D2F6 F6F6 F6F6 F6FF"
	$"FFF6 F6D2 F6F6 D2F6 F6FF 00FF F6F6 D2F6"
	$"F6D2 F6F6 FF00 FFF6 D2F6 F6F6 D2F6 F6FF"
	$"FFF6 F6D2 F6F6 D2F6 F6FF 00FF F6F6 D2D2"
	$"D2F6 F6F6 FF00 FFF6 F6D2 D2D2 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6D2 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 2323"
	$"23F6 F6F6 FF00 FFF6 D2D2 D2D2 D2F6 F6FF"
	$"FFF6 D2D2 D2D2 D2F6 F6FF 00FF F623 2323"
	$"2323 F6F6 FF00 FFF6 F6F6 D2F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 D2F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 D2D2 D2D2 D2F6 F6FF"
	$"FFF6 F6F6 F6F6 D2F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6D2 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFF6 F6F6 23F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F623 F6F6 F6FF"
	$"FFF6 F623 23F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F623 23F6 F6FF"
	$"FFF6 2323 2323 2323 F6FF 00FF F623 2323"
	$"2323 F6F6 FF00 FFF6 2323 2323 2323 F6FF"
	$"FFF6 F623 23F6 F6F6 F6FF 00FF F6F6 2323"
	$"23F6 F6F6 FF00 FFF6 F6F6 F623 23F6 F6FF"
	$"FFF6 F6F6 23F6 F6F6 F6FF 00FF F6F6 F623"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F623 F6F6 F6FF"
	$"FFF6 F6F6 F6F6 F6F6 F6FF 00FF F6F6 F6F6"
	$"F6F6 F6F6 FF00 FFF6 F6F6 F6F6 F6F6 F6FF"
	$"FFFF FFFF FFFF FFFF FFFF 00FF FFFF FFFF"
	$"FFFF FFFF FF00 FFFF FFFF FFFF FFFF FFFF"
};

resource 'icl4' (12325) {
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FCCC 66CC CF0F CC66 6CCC F0FC C666 CCCF"
	$"FCC6 CC6C CF0F CC6C C6CC F0FC 6CCC 6CCF"
	$"FCC6 CC6C CF0F CC66 6CCC F0FC 6CCC CCCF"
	$"FCC6 666C CF0F CC6C C6CC F0FC 6CCC CCCF"
	$"FCC6 CC6C CF0F CC6C C6CC F0FC 6CCC 6CCF"
	$"FCC6 CC6C CF0F CC66 6CCC F0FC C666 CCCF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FCCC CCCC CF0F CCC3 CCCC F0FC CCC6 CCCF"
	$"FCCC CCCC CF0F CC33 3CCC F0FC 6666 6CCF"
	$"FC66 666C CF0F C333 33CC F0FC CC6C CCCF"
	$"FCCC CC6C CF0F CCC3 CCCC F0FC 6666 6CCF"
	$"FCCC CC6C CF0F CCC3 CCCC F0FC C6CC CCCF"
	$"FCCC CCCC CF0F CCC3 CCCC F0FC CCCC CCCF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FCCC CCCC CF0F CCC3 CCCC F0FC CCCC CCCF"
	$"FCCC 3CCC CF0F CCC3 CCCC F0FC CCC3 CCCF"
	$"FCC3 3CCC CF0F CCC3 CCCC F0FC CCC3 3CCF"
	$"FC33 3333 CF0F C333 33CC F0FC 3333 33CF"
	$"FCC3 3CCC CF0F CC33 3CCC F0FC CCC3 3CCF"
	$"FCCC 3CCC CF0F CCC3 CCCC F0FC CCC3 CCCF"
	$"FCCC CCCC CF0F CCCC CCCC F0FC CCCC CCCF"
	$"FFFF FFFF FF0F FFFF FFFF F0FF FFFF FFFF"
};

resource 'ics8' (12325) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF00"
	$"00FF D2D2 FF00 FFD2 F6FF 00FF F6F6 FF00"
	$"00FF F6F6 FF00 FFD2 F6FF 00FF D2D2 FF00"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF00"
	$"00FF F6D2 FF00 FF23 23FF 00FF F6D2 FF00"
	$"00FF F6D2 FF00 FFF6 F6FF 00FF D2F6 FF00"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF00"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF00"
	$"00FF 23F6 FF00 FFF6 F6FF 00FF F623 FF00"
	$"00FF 23F6 FF00 FF23 23FF 00FF F623 FF00"
	$"00FF FFFF FF00 FFFF FFFF 00FF FFFF FF"
};

resource 'ics4' (12325) {
	$"0000 0000 0000 0000 0FFF F0FF FF0F FFF0"
	$"0F66 F0F6 CF0F CCF0 0FCC F0F6 CF0F 66F0"
	$"0FFF F0FF FF0F FFF0 0000 0000 0000 0000"
	$"0FFF F0FF FF0F FFF0 0FC6 F0F3 3F0F C6F0"
	$"0FC6 F0FC CF0F 6CF0 0FFF F0FF FF0F FFF0"
	$"0000 0000 0000 0000 0FFF F0FF FF0F FFF0"
	$"0F3C F0FC CF0F C3F0 0F3C F0F3 3F0F C3F0"
	$"0FFF F0FF FF0F FFF0"
};
