/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.4d7  April, 1992
 *  Copyright (c) 1988, 1989, 1990, 1991, 1992 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <StdIO.h>
#include <String.h>
 
unsigned char codeline[128];
unsigned char typebuff[256];
unsigned char databuff[256];
unsigned char aplbuff[256];
unsigned char hexbuff[8];
unsigned char outline[128];

unsigned char ebc64[] = {
	0x40,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,
	0xc8,0xc9,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,
	0x50,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,
	0xd8,0xd9,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,
	0x60,0x61,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,
	0xe8,0xe9,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
	0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,
	0xf8,0xf9,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f};
 
main()
{
int i, j, index, i1, i2, lnum;
unsigned char * rc;
unsigned char s1[64];
unsigned char s2[64];
unsigned char s3[64];
unsigned char type, val, apl, ge;
FILE *infile, *outfile, *namefile;

for (i=0; i < 256; i++) 
	typebuff[i] = databuff[i] = aplbuff[i] = 0;
	
typebuff[254] = 0x01;		/* 0x01 for ALA support */

infile = fopen("keycodes.memo", "r");
if (infile == 0) {
	printf("Error opening keycodes.memo\n");
	return;
	}
	
namefile = fopen("kbnames.new", "w");
if (namefile == 0) {
	printf("Error creating kbnames.new\n");
	return;
	}
fprintf(namefile, "static unsigned char * namelist[] = {\n");

rc = fgets(codeline, 128, infile);	/* skip first line */
rc = fgets(codeline, 128, infile);
lnum = 2;
index = 0;
while (rc != 0) {
	sscanf(codeline,
	"%s %x %x %s %s",
	s1, &i1, &i2, s2, s3);
	type = s1[0];
	val = i1;
	apl = i2;
	ge = s2[0];
	fprintf(namefile, "\t/* %03d */\t\"%s\",\n", index, s3);
	switch(type) {
		case 'D':	typebuff[index] = 1;
				if (ge == 'Y') typebuff[index] += 0x80;
				break;
		case 'L':	typebuff[index] = 0x41;	/* caps lock works */
				break;
		case 'A':	typebuff[index] = 2;
				break;
		case 'C':	typebuff[index] = 3;
				break;
		default: 	break;
		}
	databuff[index] = val;
	aplbuff[index] = apl;
	rc = fgets(codeline, 128, infile);
	lnum++;
	index++;
	}
fprintf(namefile, "\t};");
fclose(namefile);

outfile = fopen("kbtables.new", "w");
if (outfile == 0) {
	printf("Error creating kbtables.c\n");
	return;
	}

fputs("/* Note: This file is generated by \"genktab\".  Do not edit\n", outfile);
fputs("         this file.  Instead, make changes to \"genktab.c\".\n", outfile);
fputs(" */\n", outfile);
fputs("\n", outfile);
 
fputs("unsigned char kbtyp[] = {\n",outfile);
for (i=0; i < 256; i+= 8) {
	strcpy(outline,"	");
	for (j=0; j < 8; j++) {
		if ((i == 248) && (j == 7)) {
			sprintf(hexbuff,"0x%02x};",typebuff[i+j]);
			}
		else {
			sprintf(hexbuff,"0x%02x,",typebuff[i+j]);
			}
		strcat(outline,hexbuff);
		}
	strcat(outline,"\n");
	fputs(outline,outfile);
	}

fputs("\n", outfile);
 
fputs("unsigned char kbstd[] = {\n",outfile);
for (i=0; i < 256; i+= 8) {
	strcpy(outline,"	");
	for (j=0; j < 8; j++) {
		if ((i == 248) && (j == 7)) {
			sprintf(hexbuff,"0x%02x};",databuff[i+j]);
			}
		else {
			sprintf(hexbuff,"0x%02x,",databuff[i+j]);
			}
		strcat(outline,hexbuff);
		}
	strcat(outline,"\n");
	fputs(outline,outfile);
	}
 
fputs("\n", outfile);

fputs("unsigned char kbapl[] = {\n",outfile);
for (i=0; i < 256; i+= 8) {
	strcpy(outline,"	");
	for (j=0; j < 8; j++) {
		if ((i == 248) && (j == 7)) {
			sprintf(hexbuff,"0x%02x};",aplbuff[i+j]);
			}
		else {
			sprintf(hexbuff,"0x%02x,",aplbuff[i+j]);
			}
		strcat(outline,hexbuff);
		}
	strcat(outline,"\n");
	fputs(outline,outfile);
	}

fputs("\n", outfile);

fputs("unsigned char ebc64[] = {\n",outfile);
for (i=0; i < 64; i+= 8) {
	strcpy(outline,"	");
	for (j=0; j < 8; j++) {
		if ((i == 56) && (j == 7)) {
			sprintf(hexbuff,"0x%02x};",ebc64[i+j]);
			}
		else {
			sprintf(hexbuff,"0x%02x,",ebc64[i+j]);
			}
		strcat(outline,hexbuff);
		}
	strcat(outline,"\n");
	fputs(outline,outfile);
	}
	
fclose(outfile);
}
