/*
 *  tn3270 for the Macintosh Source Code
 *  Brown University Computing and Information Services
 *  Version 2.4d7  April, 1992
 *  Copyright (c) 1988, 1989, 1990, 1991, 1992 by Brown University and by
 *  Peter John DiCamillo.
 *
 *  Permission is granted to any individual or institution to use, copy,
 *  or redistribute the binary version of this software and its
 *  documentation provided this notice and the copyright notices are
 *  retained.  Permission is granted to any individual or non-profit
 *  institution to use, copy, modify, or redistribute the source files
 *  of this software provided this notice and the copyright notices are
 *  retained.  This software may not be distributed for profit, either
 *  in original form or in derivative works, nor can the source be
 *  distributed to other than an individual or a non-profit institution.
 *  Any  individual or group interested in seeing and/or using these
 *  source files but who are prevented from doing so by the above
 *  constraints should contact Don Wolfe, Assistant Vice-President for
 *  Computer Systems at Brown University, (401) 863-7250, for possible
 *  software licensing of the source developed at Brown.
 *
 *  Brown University and Peter John DiCamillo make no representations
 *  about the suitability of this software for any purpose.
 *
 *  BROWN UNIVERSITY AND PETER JOHN DICAMILLO GIVE NO WARRANTY, EITHER
 *  EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
 *  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND
 *  WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
 
extern char done;					/* flag for mainline to return */
extern cnr *cplist[];				/* pointers to connections records */
extern cnr *menu_cplist[];			/* pointers corresponding to conn. menu */
extern Rect screenRect;
extern Rect dragRect;
extern MenuHandle myMenus[];
extern MenuHandle kybdMenu;
extern MenuHandle nlMenu;
extern MenuHandle configMenu;
extern EventRecord myEvent;
extern Cursor *normcurs;			/* default Macintosh cursor (arrow) */
extern char dfltcurs;				/* flag to keep track of cursor */
extern RgnHandle temprgn;			/* work region */
extern scrapline * scrapstart;
extern short scrapalloc;
extern short scrapsize;
extern short scrapwidth;
extern char scrap_stdfont;
extern char scrap_repnull;
extern Handle scrap_nlhandle;
extern unsigned char scrap_nltab[];
extern char specmenu;				/* "special" menu inserted */
extern char ScrDmpSav;				/* saved ScrDmpEnb byte */
extern char sw_bgrnd;				/* running in switcher background */
extern char sw_upd;					/* update occurred in background */
extern char sw_beep;				/* beep occurred in background */
extern Point mousehit;				/* last hit in dialog box */
extern char colormac;				/* true if we have color QuickDraw */
extern char newroms;				/* Mac has 128K ROMs or newer */
extern unsigned char syslevel;		/* level of system software (1st digit) */
extern char newkybd;				/* new (ADB) keyboard in use */
extern char extkybd;				/* extended ADB keyboard in use */
extern char mf_bgrnd;				/* in background under MultiFinder */
extern char ftpcopen;				/* FTP control connection open */
extern char ftpdopen;				/* FTP data connection open */
extern char ftplopen;				/* FTP list connection open */
extern THPrint hPrint;				/* print record handle */
extern char prtinit;				/* flag for printing intialization */
extern short rowmax9;				/* maximum no. of rows for 9-point font */
extern short colmax9;				/* maximum no. of columns for 9-pt. font */
extern short rowmax12;				/* maximum no. of rows for 12-point font */
extern short colmax12;				/* maximum no. of columns for 12-pt. font */
extern Handle xtabh;				/* handle to EBCDIC to Mac ASCII xtab */
extern Handle alaxtabh;				/* handle to ALA diacritic table */
extern char sndactive;				/* true while sound is being played */
extern SndChannelPtr scp;			/* pointer for async sound channel */
extern char smgr_sppc;				/* true if session manager registered ok */
extern short smgrrefnum;			/* session manager SPPC refnum */
extern char gestaltavail;			/* Gestalt is available */
extern char ppcavail;				/* PPC is available */
extern unsigned long ppcflags;		/* PPC flags from Gestalt */
extern char smgrppc;				/* true if session mananger opened a port */
extern short smgrpref;				/* port refnum for session manager */
extern queueinfo paramqueue;		/* PPC param block queue */
extern queueinfo clientqueue;		/* PPC client record queue */
extern queueinfo dataqueue;			/* PPC data block queue */
extern char haveserial;				/* serial driver present */
extern char havetcp;				/* TCP/IP driver present */
extern char havesa;					/* standalone driver present */
extern Handle default_kybdhandle;	/* handle to default keyboard mapping */
extern cnr *pictcp;					/* pointer for saving graphics */
extern unsigned char dbgmsg[256];	/* buffer for debug messages */
extern char pasteok;				/* paste is possible now */
extern char usemyscrap;				/* do paste from private scrap */
extern char writedebug;				/* enable write tracing */

									/* from kbtab.c */
extern unsigned char kbtyp[];
extern unsigned char kbstd[];
extern unsigned char kbapl[];
extern unsigned char ebc64[];

								/* config. connection settings */
								/* (nearly all have effects before they could
								   be changed during a session) */
extern unsigned char cf_hostname[];		/* host name */
extern unsigned char cf_wtitle[];		/* window name */
extern char cf_dblevel;					/* debug level */
extern char cf_setsflg;					/* connection mode */
extern unsigned char cf_timeout;		/* seconds between retransmits */
extern unsigned char cf_retries;		/* number of retries */
extern short cf_dfltptsize;				/* default screen point size */
extern short cf_altptsize;				/* alternate screen point size */
extern short cf_altrows;				/* rows for alternate screen */
extern short cf_altcols;				/* columns for alternate screen */
extern short cf_custrows;				/* custom row size */
extern short cf_custcols;				/* custom column count */
extern char cf_windmax;					/* always use maximum window size */
extern char cf_savewpos;				/* save window position in file */
extern char cf_ext3270;					/* extended data stream support */
extern char cf_nographics;				/* don't allocate graphics bitmap */
extern char cf_nocolor;					/* bitmaps only 1 bit deep */

								/* API open information for conn. record */
extern OpenRequest apiopenreq;
extern unsigned char apihostname[];
extern unsigned char apiwindowname[];
extern short apiopenrefnum;			/* SPPC client refnum for open */
extern unsigned long apiopenmsgid;	/* SPPC/PPC message id of open request */
extern char apiopenkind;			/* 0 = PPC, 1 = SPPC */
extern unsigned long apiopensref;	/* PPC session refnum for open */

								/* work variables for new settings */
extern settings_list ns;
extern unsigned char nshostname[];
extern unsigned char nswtitle[];
extern unsigned char nskybdname[];
extern unsigned char nsnlname[];
extern unsigned char nssndname[];

								/* default settings */
extern settings_list ds;
extern unsigned char dshostname[];
extern unsigned char dswtitle[];
extern unsigned char dskybdname[];
extern unsigned char dsnlname[];
extern unsigned char dssndname[];
